package tutorial;

import java.io.File;
import java.io.IOException;
import java.util.Date;

import javax.faces.bean.ApplicationScoped;
import javax.faces.bean.ManagedBean;

import org.apache.sanselan.ImageFormat;
import org.apache.sanselan.ImageInfo;
import org.apache.sanselan.ImageReadException;
import org.apache.sanselan.Sanselan;
import org.apache.sanselan.formats.jpeg.JpegImageMetadata;
import org.idc.upload.UploadedFile;

import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.ClientResponse;
import com.sun.jersey.api.client.WebResource;
import com.sun.jersey.api.client.ClientResponse.Status;

@ManagedBean(name="Photo")
@ApplicationScoped
public class Photo
{
private String title;
private String description;
private File image;
private static Client CLIENT;


public String getTitle() {
	return title;
}


public void setTitle(String title) {
	this.title = title;
}


public String getDescription() {
	return description;
}


public void setDescription(String description) {
	this.description = description;
}


public void setImage(UploadedFile image)
  {
   if (image == null) this.image = null;
   else this.image = new File(image.getLongFileName());
      
   this.image = new File(image.getLongFileName());
   
   if (this.image.exists())
     {
      try
        {
         ImageInfo info = Sanselan.getImageInfo(this.image);
         
         System.out.println("Breite: "+info.getWidth());
         System.out.println("Hhe: "+info.getHeight());

         if (info.getFormat() == ImageFormat.IMAGE_FORMAT_JPEG)
           {
            JpegImageMetadata meta = (JpegImageMetadata)Sanselan.getMetadata(this.image);
            
            if (meta != null)
              {
            	System.out.println("Aperture: "+ExifConverter.getAperture(meta));
            	System.out.println("Exposure: "+ExifConverter.getExposureTime(meta));
            	System.out.println("Focal length: "+ExifConverter.getFocalLength(meta));
            	System.out.println("GPS Lat: "+ExifConverter.getGPSLatitude(meta));
            	System.out.println("GPS Long: "+ExifConverter.getGPSLongitude(meta));
            	System.out.println("Created: "+ExifConverter.getCreationDate(meta));               
              }
           }
        }
      catch (IOException e)
        {
         e.printStackTrace();
        }
      catch (ImageReadException e)
        {
         e.printStackTrace();
        }      
     }
  }

public UploadedFile getImage()
  {
   return null;
  }

public void commitInsert()
  {
   System.out.println("Eintrag wird gespeichert.");   
   if (this.image != null) System.out.println(this.image.getAbsolutePath());
      
   CLIENT = Client.create();
   
   String url = "http://141.76.61.48:8011/photos";   
   WebResource r = CLIENT.resource(url);
   
   try
     {      
      ClientResponse response = r.put(ClientResponse.class,image);   
      Status stat = response.getClientResponseStatus();
   
      try
        {
         response.close();
        }
      catch (Exception e) {}
   
      if (stat == Status.OK) System.out.println("File successfully uploaded.");
     }
   catch (Exception e)
     {
      e.printStackTrace();
     }
  }
}